CT_HideBAB = 0;
CT_RelocateTooltip = 0;

questfadefunction = function (modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		QUEST_FADING_ENABLE = nil;
		CT_Print("<CTMod> Quest Text Fading has been disabled.", 1.0, 1.0, 0.0);
	else
		QUEST_FADING_ENABLE = 1;
		CT_Print("<CTMod> Quest Text Fading has been enabled.", 1.0, 1.0, 0.0);
	end
end
questfadeinitfunction = function (modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		QUEST_FADING_ENABLE = nil;
	else
		QUEST_FADING_ENABLE = 1;
	end
end
CT_RegisterMod("Quest Fading", "On/Off Toggle", 5, "Interface\\Icons\\INV_Misc_Note_04", "Shows the fading Quest Text.", "on", nil, questfadefunction, questfadeinitfunction);

reloadfunction = function ()
	ConsoleExec("reloadui");
	CT_Print("<CTMod> User Interface has been reloaded.", 1, 1, 0);
end

resetfunction = function()
	CT_Print("<CTMod> For safety measures, please write /resetoptions to reset your options.", 1, 1, 0);
end

CT_RegisterMod("Reload Interface", "", 5, "Interface\\Icons\\Ability_Whirlwind", "Reloads the UI.\nShould be used after an options reset.", "switch", "", reloadfunction);
CT_RegisterMod("Reset Options", "", 5, "Interface\\Icons\\Spell_Frost_WindWalkOn", "Resets all CTMod options.", "switch", "", resetfunction);

local gryphonfunction = function(modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		CT_Print("<CTMod> The gryphons are now hidden.", 1, 1, 0);
		MainMenuBarLeftEndCap:Hide();
		MainMenuBarRightEndCap:Hide();
	else
		CT_Print("<CTMod> The gryphons are now shown.", 1, 1, 0);
		MainMenuBarLeftEndCap:Show();
		MainMenuBarRightEndCap:Show();
	end
end

local gryphoninitfunction = function(modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		MainMenuBarLeftEndCap:Hide();
		MainMenuBarRightEndCap:Hide();
	else
		MainMenuBarLeftEndCap:Show();
		MainMenuBarRightEndCap:Show();
	end
end

CT_RegisterMod("Hide Gryphons", "", 5, "Interface\\Icons\\Ability_EyeOfTheOwl", "Hides the gryphons on the side of the main menu bar.", "off", nil, gryphonfunction, gryphoninitfunction);

CT_Old_ShowSB_Update = ShapeshiftBar_Update;
function CT_ShapeshiftBar_Update()
	if ( CT_HideBAB == 1 ) then
		ShapeshiftBarFrame:Hide();
	else
		CT_Old_ShowSB_Update();
	end
end
ShapeshiftBar_Update = CT_ShapeshiftBar_Update;
	
local hidebarfunc = function(modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		CT_HideBAB = 1;
		CT_Print("<CTMod> The bonus action bars are now hidden.", 1, 1, 0);
	else
		CT_Print("<CTMod> The bonus action bars are no longer hidden.", 1, 1, 0);
		CT_HideBAB = 0;
	end
	ShapeshiftBar_Update();
end

local hidebarinitfunc = function(modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		CT_HideBAB = 1;
	else
		CT_HideBAB = 0;
	end
	ShapeshiftBar_Update();
end
CT_RegisterMod("Hide Class Bars", "", 5, "Interface\\Icons\\Spell_Nature_Sleep", "Hides the class-specific bars(such as stealth, shapeshift, stances etc).", "off", nil, hidebarfunc, hidebarinitfunc);

SlashCmdList["RESETOPTIONS"] = function(msg)
	CT_Options[UnitName("player")] = { };
	CT_Print("<CTMod> All options for this player have been reset. Please use the Reload Interface button in the Control Panel to reload interface.", 1, 1, 0);
end

SLASH_RESETOPTIONS1 = "/resetoptions";

if ( Cosmos_TurnOnFPSMove ) then
	Cosmos_TurnOnFPSMove(1);
	COS_COS_FPSMOVE = 1;
	Cosmos_RegisterCVar("COS_COS_FPSMOVE_X", 1);
else
	-- Not using Cosmos, so set it manually
	FramerateLabel:ClearAllPoints();
	FramerateLabel:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 0, 0);
end


if ( DB_VERSION ) then
	-- Reset Quest Timer Frame positioning
	QuestTimerFrame:ClearAllPoints();
	QuestTimerFrame:SetPoint("LEFT", "Minimap", "LEFT", -275, 0);
else
	-- Reset Quest Timer Frame positioning
	QuestTimerFrame:ClearAllPoints();
	QuestTimerFrame:SetPoint("LEFT", "Minimap", "LEFT", -360, 45);
end

function ct_QuestTimerFrame_OnShow()
	-- return
	return;
end
function ct_QuestTimerFrame_OnHide()
	-- return
	return;
end
-- Redefine how the show/hide happens
QuestTimerFrame_OnShow = ct_QuestTimerFrame_OnShow;
QuestTimerFrame_OnHide = ct_QuestTimerFrame_OnHide;

CT_OldDD_AddButton = UIDropDownMenu_AddButton;
function CT_NewDD_AddButton(info, level)
	if ( not level ) then
		level = 1;
	end
	
	local listFrame = getglobal("DropDownList"..level);
	local listFrameName = listFrame:GetName();
	local index = listFrame.numButtons + 1;
	local width;

	-- If too many buttons error out
	if ( index > UIDROPDOWNMENU_MAXBUTTONS ) then
		return;
	end
	CT_OldDD_AddButton(info, level);
end

UIDropDownMenu_AddButton = CT_NewDD_AddButton;

CT_oldGT_SetDefaultAnchor = GameTooltip_SetDefaultAnchor;

function CT_GT_SetDefaultAnchor(tooltip, parent) 
	if ( tooltip == GameTooltip and CT_RelocateTooltip == 1 ) then
		tooltip:SetOwner(parent, "ANCHOR_NONE");
		tooltip:ClearAllPoints();
		tooltip:SetPoint("TOP", "UIParent", "TOP");
	else
		CT_oldGT_SetDefaultAnchor(tooltip, parent);
	end
end

GameTooltip_SetDefaultAnchor = CT_GT_SetDefaultAnchor;

local relocatefunc = function(modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		CT_RelocateTooltip = 1;
		CT_Print("<CTMod> The tooltip is now showing at the top of the screen.", 1, 1, 0);
	else
		CT_Print("<CTMod> The tooltip is now showing in the bottom right corner.", 1, 1, 0);
		CT_RelocateTooltip = 0;
	end
end

local relocateinitfunc = function(modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		CT_RelocateTooltip = 1;
	else
		CT_RelocateTooltip = 0;
	end
end
CT_RegisterMod("Relocate Tooltip", "Show at top", 5, "Interface\\Icons\\INV_Misc_Map_01", "Relocates the tooltip to show at the top of the screen.", "off", nil, relocatefunc, relocateinitfunc);

CT_oldSetItemButtonCount = SetItemButtonCount;
function CT_newSetItemButtonCount(button, count)
	CT_oldSetItemButtonCount(button, count);
	getglobal(button:GetName().."Count"):SetText(button.count);
end
SetItemButtonCount = CT_newSetItemButtonCount;