CT_CurrHealth = 0;
CT_CurrMana = 0;
CT_ShowTicks = 0;
CT_PlayerRegen = 1;

originalHB_OnValueChanged = HealthBar_OnValueChanged;

function CT_HealthBar_OnValueChanged()
	originalHB_OnValueChanged(arg1, arg2);
	if ( this:GetName() ~= "PlayerFrameHealthBar" ) then return; end
	local min, max = this:GetMinMaxValues();
	if ( arg1 > CT_CurrHealth and CT_CurrHealth ~= 0 ) then
		CT_TicksHealth:SetText("HP/Tick: " .. arg1-CT_CurrHealth);
	elseif ( arg1 == max ) then
		CT_TicksHealth:SetText("HP/Tick: N/A");
	end
	CT_CurrHealth = arg1;
end

HealthBar_OnValueChanged = CT_HealthBar_OnValueChanged;

function CT_ManaTicks_OnUpdate()
	if ( CT_PlayerRegen == 0 ) then
		CT_TicksHealth:SetText("HP/Tick: N/A");
	end
	if ( UnitMana("player") == UnitManaMax("player") and UnitPowerType("player") == 0) then
		CT_TicksMana:SetText("MP/Tick: N/A");
	end
	if ( UnitPowerType("player") > 0 ) then return; end -- If player's energy type != mana
	local mana = UnitMana("player");
	if ( mana > CT_CurrMana and CT_CurrMana ~= 0 ) then
		CT_TicksMana:SetText("MP/Tick: " .. mana-CT_CurrMana);
	end
	CT_CurrMana = mana;
end

function CT_Ticks_OnEvent(event)
	if ( event == "PLAYER_REGEN_DISABLED" ) then
		CT_PlayerRegen = 0;
	elseif ( event == "PLAYER_REGEN_ENABLED" ) then
		CT_PlayerRegen = 1;
	end
end

tickfunction = function (modId)
	local val = CT_Mods[modId]["modStatus"]
	if ( val == "off" ) then
		CT_ShowTicks = 0;
		CT_Print("<CTMod> " .. CT_TICKMOD_OFF, 1.0, 1.0, 0.0);
	else
		CT_ShowTicks = 1;
		CT_Print("<CTMod> " .. CT_TICKMOD_ON, 1.0, 1.0, 0.0);
	end
end

function tickInitFunction(modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		CT_ShowTicks = 1;
	else
		CT_ShowTicks = 0;
	end
end

CT_RegisterMod(CT_TICKMOD_MODNAME, CT_TICKMOD_SUBNAME, 4, "Interface\\Icons\\Spell_Nature_HealingTouch", CT_TICKMOD_TOOLTIP, "off", nil, tickfunction, tickInitFunction);